--- vls.orig/src/modules/localinput/localinput.cpp	2003-08-11 11:15:48.000000000 +0100
+++ vls/src/modules/localinput/localinput.cpp	2003-08-12 22:19:22.000000000 +0100
@@ -345,8 +345,8 @@
     pTrickPlay->Stop();
 
     // Unregister the 2 thread and delete them
-    m_cStreamers.Delete(pBroadcast);
     m_cTrickPlay.Delete(pBroadcast);
+    m_cStreamers.Delete(pBroadcast);
 
     throw E_Exception(GEN_ERR, "unable to start streaming of program "+
                       pBroadcast->GetProgram()->GetName(), e);
@@ -468,10 +468,10 @@
   try
   {
     pStreamer->Stop();
-    delete pStreamer;
     pTrickPlay->Stop();
     delete pTrickPlay;
     delete pConverter;
+    delete pStreamer; // streamer MUST be deleted last
   }
   catch(E_Exception e)
   {
--- vls.orig/src/modules/normaltrickplay/normaltrickplay.cpp	2003-08-08 17:54:17.000000000 +0100
+++ vls/src/modules/normaltrickplay/normaltrickplay.cpp	2003-08-12 22:33:17.000000000 +0100
@@ -195,6 +195,16 @@
   // nitrox
   m_cResumeCond.Release();
   C_TrickPlay::StopWork();
+
+  // if the thread isn't already stopped, wait a second.
+  // If it STILL hasn't stopped, we will be stuck in HandlePacket()
+  // waiting for the consumer thread to remove items from the buffer.
+  // As the consumer is likely already dead, this never occurs, causing
+  // deadlock. Kill it
+  if (IsRunning()) {
+    sleep(1);
+    if (IsRunning()) Interrupt();
+  }
 }
 
 void C_NormalTrickPlay::InitWork()
